/////////////////////////////////////////////////
// incode bitmap compiler v1.0 demonstration
// (c) 1997 sven spitzmacher, germany
// if you have questions or suggestions contact
// me at sspitzmacher@bitsmart.com
/////////////////////////////////////////////////

// the included gfx may not be used in any production without
// prior written permission because its a copyrighted part of a
// commercial product written by me. it may be only used to
// demonstrate the incode bitmap compiler


#include <stdio.h>
#include <malloc.h>
#include "..\h\w32cbm.h"


#pragma aux SetVideoMode parm [ax] = "int 10h";

void SetPalette(char *palette)
{
    short i;
    outp(0x03c8, 0);
    for(i=0;i<768;i++)
        outp(0x03c9, palette[i]);
}


void main(void)
{
    FILE *file;
    short i,w,h;
    char *buf, *cbm;
    char palette[768];

    file=fopen("demo.raw", "r+b");      // load some demo picture
    if(!file)
        return;     // exit if file doesnt exist
    fseek(file, 4, SEEK_SET);           //      skip header
    fread(&w,2,1,file);                 //      read width
    fread(&h,2,1,file);                 //      read height
    fread(buf, w*h, 1, file);           //      read picture data
    fread(palette, 768, 1, file);       //      read color palette
    fclose(file);

    for(i=0;i<768;i++)      // adjust palette (its like a pcx palette)
        palette[i]>>=2;

    InCode_InitCompiler();                          // Initialize compiler
    cbm=InCode_CompileBitmap(w,h,320,buf);          // compile the bitmap
    if(!cbm) // error? (not enuff memory, etc.)
        return;
    free(buf);                          // free old raw-image

    SetVideoMode(0x13);                 // set vga to mode 13 (320x200x256)
    SetPalette(palette);                // set vga palette
    InCode_BlitCompiledBitmap(cbm,10,10,320,(char*)(0xA000<<4));    // blit the bitmap
    getch();                            // wait for a keypress
    SetVideoMode(0x03);                 // set vga back to mode 3 (80x25 text)
    free(cbm);                          // free compiled bitmaps memory
}

